
import
  preserves

type
  Query* {.preservesRecord: "query".} = object
    `statement`*: seq[Value]
    `target`* {.preservesEmbedded.}: Value

  SqlError* {.preservesRecord: "sql-error".} = object
    `msg`*: string
    `context`*: string

proc `$`*(x: Query | SqlError): string =
  `$`(toPreserves(x))

proc encode*(x: Query | SqlError): seq[byte] =
  encode(toPreserves(x))
